/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/mikrokopter-genom3/work/templates/ros/client/ros/mikrokopter_ros/msg/calibrate_imuGoal.msg
 *
 */


#ifndef MIKROKOPTER_ROS_MESSAGE_CALIBRATE_IMUGOAL_H
#define MIKROKOPTER_ROS_MESSAGE_CALIBRATE_IMUGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mikrokopter_ros
{
template <class ContainerAllocator>
struct calibrate_imuGoal_
{
  typedef calibrate_imuGoal_<ContainerAllocator> Type;

  calibrate_imuGoal_()
    : tstill(0.0)
    , nposes(0)  {
    }
  calibrate_imuGoal_(const ContainerAllocator& _alloc)
    : tstill(0.0)
    , nposes(0)  {
    }



   typedef double _tstill_type;
  _tstill_type tstill;

   typedef uint16_t _nposes_type;
  _nposes_type nposes;




  typedef boost::shared_ptr< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> const> ConstPtr;

}; // struct calibrate_imuGoal_

typedef ::mikrokopter_ros::calibrate_imuGoal_<std::allocator<void> > calibrate_imuGoal;

typedef boost::shared_ptr< ::mikrokopter_ros::calibrate_imuGoal > calibrate_imuGoalPtr;
typedef boost::shared_ptr< ::mikrokopter_ros::calibrate_imuGoal const> calibrate_imuGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mikrokopter_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'mikrokopter_ros': ['mikrokopter_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7b1ea297fdcff9e5fd5ab82c503969f8";
  }

  static const char* value(const ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7b1ea297fdcff9e5ULL;
  static const uint64_t static_value2 = 0xfd5ab82c503969f8ULL;
};

template<class ContainerAllocator>
struct DataType< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mikrokopter_ros/calibrate_imuGoal";
  }

  static const char* value(const ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# service calibrate_imu\n\
float64 tstill\n\
uint16 nposes\n\
";
  }

  static const char* value(const ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.tstill);
      stream.next(m.nposes);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct calibrate_imuGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mikrokopter_ros::calibrate_imuGoal_<ContainerAllocator>& v)
  {
    s << indent << "tstill: ";
    Printer<double>::stream(s, indent + "  ", v.tstill);
    s << indent << "nposes: ";
    Printer<uint16_t>::stream(s, indent + "  ", v.nposes);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MIKROKOPTER_ROS_MESSAGE_CALIBRATE_IMUGOAL_H
