/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/mikrokopter-genom3/work/templates/ros/client/ros/mikrokopter_ros/msg/or_rotorcraft_input.msg
 *
 */


#ifndef MIKROKOPTER_ROS_MESSAGE_OR_ROTORCRAFT_INPUT_H
#define MIKROKOPTER_ROS_MESSAGE_OR_ROTORCRAFT_INPUT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mikrokopter_ros/or_time_ts.h>
#include <mikrokopter_ros/or_rotorcraft_control_type.h>
#include <mikrokopter_ros/or_rotorcraft_rotor_control.h>

namespace mikrokopter_ros
{
template <class ContainerAllocator>
struct or_rotorcraft_input_
{
  typedef or_rotorcraft_input_<ContainerAllocator> Type;

  or_rotorcraft_input_()
    : ts()
    , control()
    , desired()  {
    }
  or_rotorcraft_input_(const ContainerAllocator& _alloc)
    : ts(_alloc)
    , control(_alloc)
    , desired(_alloc)  {
    }



   typedef  ::mikrokopter_ros::or_time_ts_<ContainerAllocator>  _ts_type;
  _ts_type ts;

   typedef  ::mikrokopter_ros::or_rotorcraft_control_type_<ContainerAllocator>  _control_type;
  _control_type control;

   typedef  ::mikrokopter_ros::or_rotorcraft_rotor_control_<ContainerAllocator>  _desired_type;
  _desired_type desired;




  typedef boost::shared_ptr< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> const> ConstPtr;

}; // struct or_rotorcraft_input_

typedef ::mikrokopter_ros::or_rotorcraft_input_<std::allocator<void> > or_rotorcraft_input;

typedef boost::shared_ptr< ::mikrokopter_ros::or_rotorcraft_input > or_rotorcraft_inputPtr;
typedef boost::shared_ptr< ::mikrokopter_ros::or_rotorcraft_input const> or_rotorcraft_inputConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mikrokopter_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'mikrokopter_ros': ['mikrokopter_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0511c0ac383494c8b6cba4b6dfb80f79";
  }

  static const char* value(const ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0511c0ac383494c8ULL;
  static const uint64_t static_value2 = 0xb6cba4b6dfb80f79ULL;
};

template<class ContainerAllocator>
struct DataType< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mikrokopter_ros/or_rotorcraft_input";
  }

  static const char* value(const ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::or_rotorcraft::input\n\
or_time_ts ts\n\
or_rotorcraft_control_type control\n\
or_rotorcraft_rotor_control desired\n\
\n\
================================================================================\n\
MSG: mikrokopter_ros/or_time_ts\n\
# IDL struct ::or::time::ts\n\
uint32 sec\n\
uint32 nsec\n\
\n\
================================================================================\n\
MSG: mikrokopter_ros/or_rotorcraft_control_type\n\
# IDL enum ::or_rotorcraft::control_type\n\
uint32 or_rotorcraft_velocity = 0\n\
uint32 or_rotorcraft_throttle = 1\n\
\n\
uint32 value\n\
\n\
================================================================================\n\
MSG: mikrokopter_ros/or_rotorcraft_rotor_control\n\
# IDL typedef ::or_rotorcraft::rotor_control\n\
float64[] rotor_control\n\
";
  }

  static const char* value(const ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.ts);
      stream.next(m.control);
      stream.next(m.desired);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct or_rotorcraft_input_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mikrokopter_ros::or_rotorcraft_input_<ContainerAllocator>& v)
  {
    s << indent << "ts: ";
    s << std::endl;
    Printer< ::mikrokopter_ros::or_time_ts_<ContainerAllocator> >::stream(s, indent + "  ", v.ts);
    s << indent << "control: ";
    s << std::endl;
    Printer< ::mikrokopter_ros::or_rotorcraft_control_type_<ContainerAllocator> >::stream(s, indent + "  ", v.control);
    s << indent << "desired: ";
    s << std::endl;
    Printer< ::mikrokopter_ros::or_rotorcraft_rotor_control_<ContainerAllocator> >::stream(s, indent + "  ", v.desired);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MIKROKOPTER_ROS_MESSAGE_OR_ROTORCRAFT_INPUT_H
